program test_qz
  !use mkl95_precision, only : wp => dp
  use gensys

  implicit none 

  integer :: narg, ns

  double precision, allocatable, dimension(:,:) :: GAM0, GAM1
  complex*16, allocatable, dimension(:, :) :: Q, Z, A, B
  complex*16, allocatable, dimension(:) :: alpha, beta

  double precision :: tol, g1_score, g0_score

  integer :: info, i
  character(len=144) :: ns_str, fhGAM0, fhGAM1, outstr, fname
  narg = command_argument_count()

  if (narg == 0) then
     ns = 50
     fhGAM0 = '/mq/home/m1eph00/tmp/gensys-c/GAM0.txt'
     fhGAM1 = '/mq/home/m1eph00/tmp/gensys-c/GAM1.txt'
     outstr = '(50f16.8)'
     fname = 'sw'
  elseif (narg == 4) then 
     call get_command_argument(1, fname)
     call get_command_argument(2, ns_str)
     read(ns_str, * ) ns

     call get_command_argument(3, fhGAM0)
     call get_command_argument(4, fhGAM1)

     outstr = '('//trim(ns_str)//'f16.8)'
  else
     print '(a,/)', 'test_qz requires 0 or 3 cmd line arguments.'
     stop
  endif

  allocate(GAM0(ns,ns), GAM1(ns,ns))
  !load gam1 gam2
  open(1, file=trim(fhGAM0), status='old', action='read')
  open(2, file=trim(fhGAM1), status='old', action='read')  
  do i = 1, ns
     read(1,*) GAM0(i,1:ns)
     read(2,*) GAM1(i,1:ns)
  end do

  close(1)
  close(2)
!  GAM0 = dble(GAM0*1.0d0)
!  GAM1 = dble(GAM1*1.0d0)
  zxz = .false.
  nunstab = 0
  stake = 1.01d0
  tol = 1.0e-13
  allocate(A(ns,ns), B(ns,ns), Q(ns,ns), Z(ns,ns), alpha(ns), beta(ns))

  call qz(GAM0, GAM1, A, B, Q, Z, alpha, beta, ns, info)

  open(1, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90qreal.txt', action='write')
  open(2, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90qimag.txt', action='write')  
  
  do i = 1, ns
     write(1,outstr) real(Q(i,:))
     write(2,outstr) aimag(Q(i,:))
  end do

  close(1)
  close(2)

  open(1, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90zreal.txt', action='write')
  open(2, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90zimag.txt', action='write')  
  
  do i = 1, ns
     write(1,outstr) real(Z(i,:))
     write(2,outstr) aimag(Z(i,:))
  end do

  close(1)
  close(2)

  open(1, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90areal.txt', action='write')
  open(2, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90aimag.txt', action='write')  
  
  do i = 1, ns
     write(1,outstr) real(A(i,:))
     write(2,outstr) aimag(A(i,:))
  end do

  close(1)
  close(2)

  open(1, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90breal.txt', action='write')
  open(2, file='/mq/home/m1eph00/tmp/gensys-c/f'//trim(fname)//'90bimag.txt', action='write')  
  
  do i = 1, ns
     write(1,outstr) real(B(i,:))
     write(2,outstr) aimag(B(i,:))
  end do

  close(1)
  close(2)

  g0_score = maxval(abs(GAM0 - real(matmul(Q,matmul(A,transpose(conjg(Z)))))))
  g1_score = maxval(abs(GAM1 - real(matmul(Q,matmul(B,transpose(conjg(Z)))))))

  !print*,'Max difference     :', sum(abs(GAM0 - matmul(Q,matmul(A,transpose(Z)))))
  !print*,'QZ exited with code: ', info

  if (g0_score < tol .and. g1_score < tol) then
     print*, "QZ -- PASSED."
  else
     print*,"QZ -- FAILED.", max(g0_score,g1_score), 'info = ', info
  endif

  deallocate(GAM0, GAM1, A, B, Q, Z, alpha, beta)

end program test_qz
