program test_qz_stack_overflow
  implicit none 

  integer, parameter :: ns = 3

  double precision, dimension(ns,ns) :: A, B, QSZt
  complex*16, dimension(ns, ns) :: Q, Z, S, T
  complex*16, dimension(ns) :: alpha, beta

  double precision :: tol, g1_score, g0_score

  integer :: info

  ! test case
  A = reshape((/0.81472369d0, 0.90579194d0, 0.12698682d0, &
       0.70604609d0, 0.03183285d0, 0.27692298d0, &
       0.75126706d0,  0.25509512d0, 0.50595705d0/),shape(A))

  B = reshape((/0.98793473d0, 0.17043202d0, 0.25779225d0, &
       0.12487276d0, 0.02443402d0, 0.29018527d0, &
       0.80920385d0, 0.74861887d0, 0.12018702d0/),shape(B))

  tol = 1.0e-8

  call qz(A, B, S, T, Q, Z, alpha, beta, ns, info)
  print*,Q
  print*,S
  print*,Z
  ! Compute Q*S*Z' -- should be equal to A
  QSZt = real(matmul(Q, matmul(S, transpose(conjg(Z)))))

  print*, 'QZ returned info = ', info

  print*, 'A = '
  write(*,'(3f7.3)') transpose(A)
  print*,'\n Q*S*Z` = '
  write(*,'(3f7.3)') transpose(QSZt)


end program test_qz_stack_overflow

subroutine qz(a, b, s, t, q, z, alpha, beta, n, info)

  double precision, intent(in) :: a(n,n), b(n,n)
  complex*16, intent(out), dimension(n,n) :: q, z, s, t
  complex*16, intent(out) :: alpha(n), beta(n)
  integer, intent(out) :: info

  integer :: n, sdim, lwork
  complex*16, dimension(n, n) :: cplxa, cplxb
  complex*16, allocatable :: work(:)
  double precision, dimension(8*n) :: rwork
  logical, dimension(4*n) :: bwork

  s = dcmplx(a)
  t = dcmplx(b)

  lwork = 5*n**2
  allocate(work(lwork))
  !delctg is not referenced
  call zgges('V','V','N', delctg, n, s, n, t, n, sdim, alpha, beta, q, &
       n, z, n, work, lwork, rwork, bwork, info)

  deallocate(work)
end subroutine qz

! Matlab 
